/// The end represents the first timestamp that does not belong to the range. If absent, there is no known
/// end to the range.
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct Range {
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "start", skip_serializing_if = "Option::is_none", default)]
    start: Option<Box<super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::super::api::Timestamp>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "end", skip_serializing_if = "Option::is_none", default)]
    end: Option<Box<super::super::super::super::api::Timestamp>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::RangeValue>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "value", skip_serializing_if = "Option::is_none", default)]
    value: Option<Box<super::RangeValue>>,
}
impl Range {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    #[inline]
    pub fn start(&self) -> Option<&super::super::super::super::api::Timestamp> {
        self.start.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn end(&self) -> Option<&super::super::super::super::api::Timestamp> {
        self.end.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn value(&self) -> Option<&super::RangeValue> {
        self.value.as_ref().map(|o| &**o)
    }
}
